<template>
  <div class="blog-page">
    <div class="table-head">
      <el-button type="primary" @click="show_update_dialog = true"
        >Add</el-button
      >

      <el-input
        v-model="search"
        placeholder="Search"
        class="input-search"
      ></el-input>
    </div>

    <el-table height="250" :data="table_data" style="width: 100%">
      <el-table-column prop="admin" label="Admin" min-width="250">
      </el-table-column>

      <el-table-column prop="status" label="Status" min-width="120">
        <template slot-scope="scope">
          <el-tag
            v-if="scope.row.status === 'public'"
            type="success"
            effect="dark"
            >Public</el-tag
          >

          <el-tag
            v-if="scope.row.status === 'draft'"
            type="warning"
            effect="dark"
            >Draft</el-tag
          >
        </template>
      </el-table-column>

      <el-table-column prop="date_time" label="Date/Time" width="200">
      </el-table-column>

      <el-table-column label="" min-width="50">
        <template slot-scope="scope">
          <span class="material-icons btn-edit">edit</span>
        </template>
      </el-table-column>

      <el-table-column label="" min-width="50">
        <template slot-scope="scope">
          <span class="material-icons btn-delete">delete</span>
        </template>
      </el-table-column>
    </el-table>

    <div class="pagination">
      <span>First</span>

      <el-pagination small layout="prev, pager, next" :total="50">
      </el-pagination>

      <span>Last</span>
    </div>

    <el-dialog
      title="Update blog"
      :visible.sync="show_update_dialog"
      width="620px"
    >
      <el-form
        ref="form"
        :model="form"
        label-position="top"
        label-width="120px"
      >
        <el-form-item label="Title">
          <el-input v-model="form.title" placeholder="Title"></el-input>
        </el-form-item>

        <el-form-item label="Upload image">
          <el-row :gutter="16" class="input-upload">
            <el-col :span="18">
              <div class="file-name">
                {{ form.image_file.name || "File name" }}
              </div>

              <div class="el-upload__tip">
                *file: png, jpg. size: 624x350 px (Scale 16:9)
              </div>
            </el-col>

            <el-col :span="6">
              <el-upload
                action
                :show-file-list="false"
                :on-success="uploadFileSuccess"
                :before-upload="beforeFileUpload"
              >
                <el-button type="primary" plain>Add image</el-button>
              </el-upload>
            </el-col>
          </el-row>
        </el-form-item>

        <el-form-item label="Text">
          <el-input
            v-model="form.text"
            :autosize="{ minRows: 8, maxRows: 8 }"
            type="textarea"
            placeholder="Write something..."
            show-word-limit
            maxlength="3500"
          ></el-input>
        </el-form-item>
      </el-form>

      <span slot="footer" class="dialog-footer">
        <el-button type="success" @click="show_update_dialog = false"
          >Public</el-button
        >

        <el-button type="primary" @click="show_update_dialog = false"
          >Save draft</el-button
        >
      </span>
    </el-dialog>
  </div>
</template>

<script>
export default {
  data() {
    return {
      table_data: [
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "public",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
        {
          admin: "Siripa Boobmee (Admin2)",
          status: "draft",
          date_time: "26/06/2021 16:40",
        },
      ],
      search: "",
      show_update_dialog: false,
      form: {
        title: "",
        image_file: {},
        text: "",
      },
    }
  },
  methods: {
    uploadFileSuccess(res, file) {
      this.form.image_file = file.raw
    },
    beforeFileUpload(file) {
      const is_image = ["image/jpeg", "image/jpg", "image/png"].includes(
        file.type
      )
      const isLt2M = file.size / 1024 / 1024 < 10

      if (!is_image) {
        this.$message.error("Avatar picture must be JPG format!")
      }
      if (!isLt2M) {
        this.$message.error("Avatar picture size can not exceed 10MB!")
      }
      return is_image && isLt2M
    },
  },
}
</script>

<style lang="scss" scoped>
.table-head {
  display: flex;
  align-items: center;
  justify-content: space-between;
  .input-search {
    width: 270px;
  }
}
.el-table {
  height: calc(100vh - 233px) !important;
  .btn-edit {
    cursor: pointer;
  }
  .btn-delete {
    cursor: pointer;
    color: $color-error;
    opacity: 0.5;
  }
}
</style>
